Index: drivers/mtd/nand/spia.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/mtd/nand/spia.c,v
retrieving revision 1.1
retrieving revision 1.3
diff -u -r1.1 -r1.3
--- drivers/mtd/nand/spia.c	22 Jul 2004 19:49:46 -0000	1.1
+++ drivers/mtd/nand/spia.c	3 Nov 2004 00:04:44 -0000	1.3
@@ -1,14 +1,14 @@
 /*
  *  drivers/mtd/nand/spia.c
  *
- *  Copyright (C) 2000 Steven J. Hill (sjhill@cotw.com)
+ *  Copyright (C) 2000 Steven J. Hill (sjhill@realitydiluted.com)
  *
  *
  *	10-29-2001 TG	change to support hardwarespecific access
  *			to controllines	(due to change in nand.c)
  *			page_cache added
  *
- * $Id: spia.c,v 1.1 2004/07/22 19:49:46 joff Exp $
+ * $Id: spia.c,v 1.3 2004/11/03 00:04:44 joff Exp $
  *
  * This program is free software; you can redistribute it and/or modify
  * it under the terms of the GNU General Public License version 2 as
@@ -20,6 +20,8 @@
  *   a 64Mibit (8MiB x 8 bits) NAND flash device.
  */
 
+#include <linux/kernel.h>
+#include <linux/init.h>
 #include <linux/slab.h>
 #include <linux/module.h>
 #include <linux/mtd/mtd.h>
@@ -35,14 +37,14 @@
 /*
  * Values specific to the SPIA board (used with EP7212 processor)
  */
-#define SPIA_IO_ADDR	= 0xd0000000	/* Start of EP7212 IO address space */
-#define SPIA_FIO_ADDR	= 0xf0000000	/* Address where flash is mapped */
-#define SPIA_PEDR	= 0x0080	/*
+#define SPIA_IO_BASE	0xd0000000	/* Start of EP7212 IO address space */
+#define SPIA_FIO_BASE	0xf0000000	/* Address where flash is mapped */
+#define SPIA_PEDR	0x0080		/*
 					 * IO offset to Port E data register
 					 * where the CLE, ALE and NCE pins
 					 * are wired to.
 					 */
-#define SPIA_PEDDR	= 0x00c0	/*
+#define SPIA_PEDDR	0x00c0		/*
 					 * IO offset to Port E data direction
 					 * register so we can control the IO
 					 * lines.
@@ -62,21 +64,20 @@
 MODULE_PARM(spia_pedr, "i");
 MODULE_PARM(spia_peddr, "i");
 
-__setup("spia_io_base=",spia_io_base);
-__setup("spia_fio_base=",spia_fio_base);
-__setup("spia_pedr=",spia_pedr);
-__setup("spia_peddr=",spia_peddr);
-
 /*
  * Define partitions for flash device
  */
 const static struct mtd_partition partition_info[] = {
-	{ name: "SPIA flash partition 1",
-	  offset: 0,
-	  size: 2*1024*1024 },
-	{ name: "SPIA flash partition 2",
-	  offset: 2*1024*1024,
-	  size: 6*1024*1024 }
+	{
+		.name	= "SPIA flash partition 1",
+		.offset	= 0,
+		.size	= 2*1024*1024
+	},
+	{
+		.name	= "SPIA flash partition 2",
+		.offset	= 2*1024*1024,
+		.size	= 6*1024*1024
+	}
 };
 #define NUM_PARTITIONS 2
 
@@ -84,7 +85,7 @@
 /* 
  *	hardware specific access to control-lines
 */
-void spia_hwcontrol(int cmd){
+static void spia_hwcontrol(struct mtd_info *mtd, int cmd){
 
     switch(cmd){
 
@@ -131,37 +132,19 @@
 	(*(volatile unsigned char *) (spia_io_base + spia_peddr)) = 0x07;
 
 	/* Set address of NAND IO lines */
-	this->IO_ADDR_R = spia_fio_base;
-	this->IO_ADDR_W = spia_fio_base;
+	this->IO_ADDR_R = (void __iomem *) spia_fio_base;
+	this->IO_ADDR_W = (void __iomem *) spia_fio_base;
 	/* Set address of hardware control function */
 	this->hwcontrol = spia_hwcontrol;
 	/* 15 us command delay time */
 	this->chip_delay = 15;		
 
 	/* Scan to find existence of the device */
-	if (nand_scan (spia_mtd)) {
+	if (nand_scan (spia_mtd, 1)) {
 		kfree (spia_mtd);
 		return -ENXIO;
 	}
 
-	/* Allocate memory for internal data buffer */
-	this->data_buf = kmalloc (sizeof(u_char) * (spia_mtd->oobblock + spia_mtd->oobsize), GFP_KERNEL);
-	if (!this->data_buf) {
-		printk ("Unable to allocate NAND data buffer for SPIA.\n");
-		kfree (spia_mtd);
-		return -ENOMEM;
-	}
-
-	/* Allocate memory for internal data buffer */
-	this->data_cache = kmalloc (sizeof(u_char) * (spia_mtd->oobblock + spia_mtd->oobsize), GFP_KERNEL);
-	if (!this->data_cache) {
-		printk ("Unable to allocate NAND data cache for SPIA.\n");
-		kfree (this->data_buf);
-		kfree (spia_mtd);
-		return = -ENOMEM;
-	}
-	this->cache_page = -1;
-
 	/* Register the partitions */
 	add_mtd_partitions(spia_mtd, partition_info, NUM_PARTITIONS);
 
@@ -176,14 +159,8 @@
 #ifdef MODULE
 static void __exit spia_cleanup (void)
 {
-	struct nand_chip *this = (struct nand_chip *) &spia_mtd[1];
-
-	/* Unregister the device */
-	del_mtd_device (spia_mtd);
-
-	/* Free internal data buffer */
-	kfree (this->data_buf);
-	kfree (this->page_cache);
+	/* Release resources, unregister device */
+	nand_release (spia_mtd);
 
 	/* Free the MTD device structure */
 	kfree (spia_mtd);
@@ -192,5 +169,5 @@
 #endif
 
 MODULE_LICENSE("GPL");
-MODULE_AUTHOR("Steven J. Hill <sjhill@cotw.com");
+MODULE_AUTHOR("Steven J. Hill <sjhill@realitydiluted.com");
 MODULE_DESCRIPTION("Board-specific glue layer for NAND flash on SPIA board");
Index: drivers/mtd/nand/ts7250.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/mtd/nand/ts7250.c,v
retrieving revision 1.1
retrieving revision 1.8
diff -u -r1.1 -r1.8
--- drivers/mtd/nand/ts7250.c	3 Nov 2004 00:04:44 -0000	1.1
+++ drivers/mtd/nand/ts7250.c	16 Mar 2007 17:13:19 -0000	1.8
@@ -9,7 +9,7 @@
  *  Derived from drivers/mtd/nand/autcpu12.c
  *       Copyright (c) 2001 Thomas Gleixner (gleixner@autronix.de)
  *
- * $Id: ts7250.c,v 1.1 2004/11/03 00:04:44 joff Exp $
+ * $Id: ts7250.c,v 1.8 2007/03/16 17:13:19 eddie Exp $
  *
  * This program is free software; you can redistribute it and/or modify
  * it under the terms of the GNU General Public License version 2 as
@@ -30,6 +30,31 @@
 #include <asm/arch/hardware.h>
 #include <asm/sizes.h>
 
+struct partition_info { // little-endian format
+  unsigned int bootable:8; // 0x80 = active, 0x00 = don't use for booting
+  unsigned int starting_head:8;
+  unsigned int starting_csect:8;
+  unsigned int starting_xcyl:8;
+  // MSB bits 0-5 are sector
+  unsigned int system_id:8; // format of partition
+  unsigned int ending_head:8;
+  unsigned int ending_csect:8;
+  unsigned int ending_xcyl:8;
+  unsigned int relative_sector:32; // sector offset from start of disk to start of volume
+  unsigned int total_sectors:32;
+} __attribute__((packed));
+
+struct partition_table {
+  struct partition_info part[4];
+} __attribute__((__packed__));
+
+struct MBR {
+  char bootcode[446];
+  struct partition_table pt;
+  unsigned int sig55:8;
+  unsigned int sigAA:8;
+} __attribute__((__packed__));
+
 /*
  * MTD structure for TS7250 board
  */
@@ -40,24 +65,56 @@
  * Module stuff
  */
 
-static unsigned int ts7250_fio_pbase = TS7XXX_FLASH3_BASE;
+static unsigned int ts7250_nandctrl = IO_ADDRESS(TS7XXX_NAND_FLASH_CTRL);
+static unsigned int ts7250_nandbusy = IO_ADDRESS(TS7XXX_NAND_FLASH_BUSY);
 
 #ifdef CONFIG_MTD_PARTITIONS
 /*
  * Define static partitions for flash device
  */
-static struct mtd_partition partition_info[] = {
-	{ .name= "TS-BOOTROM",
+static struct mtd_partition partition_info32[] = {
+        { .name= "TS-BOOTROM",
+                  .offset= 0,
+                  .size= 0x4000 },
+        { .name= "Linux",
+                  .offset= 0x4000,
+                  .size= 0x1d00000 },
+        { .name= "RedBoot",
+                  .offset= 0x1d04000,
+                  .size= 0x2fc000 },
+};
+/*
+ * Define static partitions for flash device
+ */
+static struct mtd_partition partition_info128[] = {
+        { .name= "TS-BOOTROM",
+                  .offset= 0,
+                  .size= 0x4000 },
+        { .name= "Linux",
+                  .offset= 0x4000,
+                  .size= 0x7d00000 },
+        { .name= "RedBoot",
+                  .offset= 0x7d04000,
+                  .size= 0x2fc000 },
+};
+
+static struct mtd_partition partition_mbr[] = {
+	{ .name= "whole chip",
 		  .offset= 0,
-		  .size= 0x20000 },
-	{ .name= "Linux",
-		  .offset= 0x20000,
-		  .size= 0x1e00000 },
-	{ .name= "RedBoot",
-		  .offset= 0x1e20000,
-		  .size= 0x1e0000 },
+		  .size= 0x2000000 },
+	{ .name= "kernel",
+		  .offset= 0x4000,
+		  .size= 0x200000 },
+	{ .name= "initrd",
+		  .offset= 0x204000,
+		  .size= 0x200000 },
+	{ .name= "rootfs",
+		  .offset= 0x404000,
+		  .size= 0x2000000 - 0x404000 },
+	{ .name= "part4",
+		  .offset= 0x2000000,
+		  .size= 0 },
 };
-#define NUM_PARTITIONS 3
 
 extern int parse_cmdline_partitions(struct mtd_info *master, 
 				    struct mtd_partition **pparts,
@@ -73,36 +130,72 @@
 	switch(cmd) {
 		
 	case NAND_CTL_SETCLE: 
-		writeb(readb(IO_ADDRESS(TS7XXX_NAND_FLASH2_CTRL)) | 0x2, IO_ADDRESS(TS7XXX_NAND_FLASH2_CTRL));
+		writeb(readb(ts7250_nandctrl) | 0x2, ts7250_nandctrl);
 		break;
 	case NAND_CTL_CLRCLE: 
-		writeb(readb(IO_ADDRESS(TS7XXX_NAND_FLASH2_CTRL)) & ~0x2, IO_ADDRESS(TS7XXX_NAND_FLASH2_CTRL));
+		writeb(readb(ts7250_nandctrl) & ~0x2, ts7250_nandctrl);
 		break;
 		
 	case NAND_CTL_SETALE:
-		writeb(readb(IO_ADDRESS(TS7XXX_NAND_FLASH2_CTRL)) | 0x1, IO_ADDRESS(TS7XXX_NAND_FLASH2_CTRL));
+		writeb(readb(ts7250_nandctrl) | 0x1, ts7250_nandctrl);
 		break;
 	case NAND_CTL_CLRALE:
-		writeb(readb(IO_ADDRESS(TS7XXX_NAND_FLASH2_CTRL)) & ~0x1, IO_ADDRESS(TS7XXX_NAND_FLASH2_CTRL));
+		writeb(readb(ts7250_nandctrl) & ~0x1, ts7250_nandctrl);
 		break;
 		
 	case NAND_CTL_SETNCE:
-		writeb(readb(IO_ADDRESS(TS7XXX_NAND_FLASH2_CTRL)) | 0x4, IO_ADDRESS(TS7XXX_NAND_FLASH2_CTRL));
+		writeb(readb(ts7250_nandctrl) | 0x4, ts7250_nandctrl);
 		break;
 	case NAND_CTL_CLRNCE:
-		writeb(readb(IO_ADDRESS(TS7XXX_NAND_FLASH2_CTRL)) & ~0x4, IO_ADDRESS(TS7XXX_NAND_FLASH2_CTRL));
+		writeb(readb(ts7250_nandctrl) & ~0x4, ts7250_nandctrl);
 		break;
 	}
 }
 
+static void ts7250_enable_hwecc(struct mtd_info *mtd,int dir) {
+  volatile int *ts7x = (void *)IO_ADDRESS(TS7XXX_NAND_FLASH_CTRL);
+  int dummy;
+
+  dummy = *ts7x;
+  //printk("enable_hwecc\n");
+}
+
+static int ts7250_calculate_ecc(struct mtd_info *mtd, const u_char *dat, u_char *ecc_code) {
+     volatile int *ts7x = (void *)IO_ADDRESS(TS7XXX_NAND_FLASH_CTRL);
+     int dummy;
+
+     dummy =  0xFFFFFF & ((*ts7x >> 6) | 3);
+     //printk("Hardware ECC: %06X ",dummy);
+     ecc_code[0] = (dummy >> 16) & 0xFF;
+     ecc_code[1] = (dummy >> 8) & 0xFF;
+     ecc_code[2] = (dummy >> 0) & 0xFF;
+     //printk("(%02X %02X %02X)\n",ecc_code[0],ecc_code[1],ecc_code[2]);
+     return dummy;
+}
+
+static int detect_hwecc(struct nand_chip *this) {
+  volatile int *ts7x = (void *)IO_ADDRESS(TS7XXX_NAND_FLASH_CTRL);
+  int dummy;
+
+  dummy = *ts7x;
+  dummy = *ts7x;
+  if ((dummy >> 8) != -1) {
+    return 0;
+  }
+  writeb(0x1, this->IO_ADDR_W);
+  dummy = *ts7x;
+   return ((dummy >> 8) != -1);
+}
+
 /*
  *	read device ready pin
  */
 static int ts7250_device_ready(struct mtd_info *mtd)
 {
-	return readb(IO_ADDRESS(TS7XXX_NAND_FLASH2_BUSY)) & 0x20;
+	return readb(ts7250_nandbusy) & 0x20;
 }
 
+extern int nand_correct_data(struct mtd_info *mtd, u_char *dat, u_char *read_ecc, u_char *calc_ecc);
 /*
  * Main initialization routine
  */
@@ -112,6 +205,14 @@
 	const char *part_type = 0;
 	int mtd_parts_nb = 0;
 	struct mtd_partition *mtd_parts = 0;
+	char buf[512];
+	int i,got = 0,parts=0,hwecc = 0;
+	unsigned ofs=0;
+	volatile unsigned short *tsmodel;
+	struct MBR *mbr = (struct MBR *)buf;
+
+	if (readb(IO_ADDRESS(TS7XXX_MODEL)) == 0x0)  /* is TS-7200 */
+		return -ENXIO;
 	
 	/* Allocate memory for MTD device structure and private data */
 	ts7250_mtd = kmalloc(sizeof(struct mtd_info) + 
@@ -134,20 +235,79 @@
 	
 	
 	/* insert callbacks */
-	this->IO_ADDR_R = IO_ADDRESS(TS7XXX_NAND_FLASH2_DATA);
-	this->IO_ADDR_W = IO_ADDRESS(TS7XXX_NAND_FLASH2_DATA);
+	if (readb(IO_ADDRESS(TS7XXX_STATUS2)) & 0x4) { 
+		this->IO_ADDR_R = (void *)IO_ADDRESS(TS7XXX_NAND_FLASH2_DATA);
+		this->IO_ADDR_W = (void *)IO_ADDRESS(TS7XXX_NAND_FLASH2_DATA);
+		ts7250_nandbusy = IO_ADDRESS(TS7XXX_NAND_FLASH2_BUSY);
+		ts7250_nandctrl = IO_ADDRESS(TS7XXX_NAND_FLASH2_CTRL);
+	} else {
+		this->IO_ADDR_R = (void *)IO_ADDRESS(TS7XXX_NAND_FLASH_DATA);
+		this->IO_ADDR_W = (void *)IO_ADDRESS(TS7XXX_NAND_FLASH_DATA);
+		ts7250_nandbusy = IO_ADDRESS(TS7XXX_NAND_FLASH_BUSY);
+		ts7250_nandctrl = IO_ADDRESS(TS7XXX_NAND_FLASH_CTRL);
+	}
+
 	this->hwcontrol = ts7250_hwcontrol;
 	this->dev_ready = ts7250_device_ready;
 	this->chip_delay = 15;
 	this->eccmode = NAND_ECC_SOFT;
-	
+	this->options = 0;
+
+	tsmodel = (short *)__ioremap(0x22000000, 2, 0);
+
 	printk("Searching for NAND flash...\n");
 	/* Scan to find existence of the device */
 	if (nand_scan (ts7250_mtd, 1)) {
 		kfree (ts7250_mtd);
 		return -ENXIO;
 	}
-	
+	for (i=0;i<512;i++) {
+	  buf[i] = 0;
+	}
+
+	if((*tsmodel & 0x07) != 0x04)  { //if the current board isn't a TS-7400
+	  if (ts7250_mtd->size >= (128 * 0x100000)) {
+	    mtd_parts = partition_info128;
+	  } else {
+	    mtd_parts = partition_info32;
+	  }
+	  parts = 3;
+	} else {
+	  hwecc = detect_hwecc(this);
+	  printk("Hardware ECC ");
+	  if (!hwecc) {
+	    printk("NOT ");
+	  } else {
+	    this->eccmode = NAND_ECC_HW3_256;
+	    this->enable_hwecc = ts7250_enable_hwecc;
+	    this->calculate_ecc = ts7250_calculate_ecc;
+	    this->correct_data = nand_correct_data;
+	  }
+	  printk("detected\n");
+
+	  if (mbr->sigAA == 0xAA && mbr->sig55 == 0x55) {
+	    for (i=0;i<4;i++) {
+	      if (mbr->pt.part[i].total_sectors) {
+		parts++;
+		partition_mbr[i+1].offset = 
+		  512 * mbr->pt.part[i].relative_sector;
+		if (i < 2) {
+		  partition_mbr[i+1].size = 
+		    512 * mbr->pt.part[i+1].relative_sector -
+		    512 * mbr->pt.part[i].relative_sector;
+		} else {
+		  partition_mbr[i+1].size = 
+		    512 * mbr->pt.part[i].total_sectors;
+		}
+		ofs = partition_mbr[i+1].offset 
+		  + partition_mbr[i+1].size;
+	      }
+	    }
+	  } else {
+	    parts = 4;
+	  }
+	  mtd_parts = partition_mbr;
+	}
 #ifdef CONFIG_MTD_CMDLINE_PARTS
 	mtd_parts_nb = parse_cmdline_partitions(ts7250_mtd, &mtd_parts, 
 						"ts7250-nand");
@@ -158,9 +318,17 @@
 #endif
 	if (mtd_parts_nb == 0)
 	{
-		mtd_parts = partition_info;
-		mtd_parts_nb = NUM_PARTITIONS;
-		part_type = "static";
+	  //mtd_parts = partition_info32;
+		/*
+		if (ts7250_mtd->size >= (128 * 0x100000))
+			mtd_parts = partition_info128;
+		*/
+		mtd_parts_nb = parts;
+		if (parts > 0) {
+		  part_type = "MBR";
+		} else {
+		  part_type = "static";
+		}
 	}
 	
 	/* Register the partitions */
@@ -177,9 +345,10 @@
  */
 static void __exit ts7250_cleanup (void)
 {
-	struct nand_chip *this = (struct nand_chip *) &ts7250_mtd[1];
+  //	struct nand_chip *this = (struct nand_chip *) &ts7250_mtd[1];
 	
 	/* Unregister the device */
+	del_mtd_partitions(ts7250_mtd);
 	del_mtd_device (ts7250_mtd);
 	
 	/* Free the MTD device structure */
Index: drivers/mtd2k/Config.in
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/mtd2k/Config.in,v
retrieving revision 1.1
retrieving revision 1.3
diff -u -r1.1 -r1.3
--- drivers/mtd2k/Config.in	9 Feb 2006 21:51:44 -0000	1.1
+++ drivers/mtd2k/Config.in	29 Sep 2006 22:31:03 -0000	1.3
@@ -1,12 +1,12 @@
 
-# $Id: Config.in,v 1.1 2006/02/09 21:51:44 michael Exp $
+# $Id: Config.in,v 1.3 2006/09/29 22:31:03 joff Exp $
 
 mainmenu_option next_comment
-comment 'Memory Technology Devices (MTD)'
+comment 'Memory Technology Devices (MTD) for 2k NAND flash'
 
-tristate 'Memory Technology Device (MTD) support' CONFIG_MTD
+tristate 'Memory Technology Device (MTD) support for 2k NAND flash' CONFIG_MTD2K
 
-if [ "$CONFIG_MTD" = "y" -o "$CONFIG_MTD" = "m" ]; then
+if [ "$CONFIG_MTD2K" = "y" -o "$CONFIG_MTD2K" = "m" ]; then
    bool 'Debugging' CONFIG_MTD_DEBUG
    if [ "$CONFIG_MTD_DEBUG" = "y" ]; then
       int '  Debugging verbosity (0 = quiet, 3 = noisy)' CONFIG_MTD_DEBUG_VERBOSE 0
@@ -26,25 +26,25 @@
    fi
 
 comment 'User Modules And Translation Layers'
-   dep_tristate '  Direct char device access to MTD devices' CONFIG_MTD_CHAR $CONFIG_MTD
-   dep_tristate '  Caching block device access to MTD devices' CONFIG_MTD_BLOCK $CONFIG_MTD
+   dep_tristate '  Direct char device access to MTD devices' CONFIG_MTD_CHAR $CONFIG_MTD2K
+   dep_tristate '  Caching block device access to MTD devices' CONFIG_MTD_BLOCK $CONFIG_MTD2K
    if [ "$CONFIG_MTD_BLOCK" = "n" -o "$CONFIG_MTD_BLOCK" = "m" ]; then
-   	dep_tristate '  Readonly block device access to MTD devices' CONFIG_MTD_BLOCK_RO $CONFIG_MTD
+   	dep_tristate '  Readonly block device access to MTD devices' CONFIG_MTD_BLOCK_RO $CONFIG_MTD2K
    fi
-   dep_tristate '  FTL (Flash Translation Layer) support' CONFIG_FTL $CONFIG_MTD
-   dep_tristate '  NFTL (NAND Flash Translation Layer) support' CONFIG_NFTL $CONFIG_MTD
+   dep_tristate '  FTL (Flash Translation Layer) support' CONFIG_FTL $CONFIG_MTD2K
+   dep_tristate '  NFTL (NAND Flash Translation Layer) support' CONFIG_NFTL $CONFIG_MTD2K
    if [ "$CONFIG_NFTL" = "y" -o "$CONFIG_NFTL" = "m" ]; then
       bool '    Write support for NFTL (BETA)' CONFIG_NFTL_RW
    fi
-   dep_tristate '  INFTL (Inverse NAND Flash Translation Layer) support' CONFIG_INFTL $CONFIG_MTD
+   dep_tristate '  INFTL (Inverse NAND Flash Translation Layer) support' CONFIG_INFTL $CONFIG_MTD2K
 
-   source drivers/mtd/chips/Config.in
+   source drivers/mtd2k/chips/Config.in
 
-   source drivers/mtd/maps/Config.in
+   source drivers/mtd2k/maps/Config.in
 
-   source drivers/mtd/devices/Config.in
+   source drivers/mtd2k/devices/Config.in
 
-   source drivers/mtd/nand/Config.in
+   source drivers/mtd2k/nand/Config.in
 
 fi
 
Index: drivers/mtd2k/Makefile
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/mtd2k/Makefile,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/mtd2k/Makefile	9 Feb 2006 21:51:44 -0000	1.1
+++ drivers/mtd2k/Makefile	9 Feb 2006 23:21:28 -0000	1.2
@@ -2,12 +2,12 @@
 # linux/drivers/Makefile.24
 # Makefile for obsolete kernels.
 #
-# $Id: Makefile,v 1.1 2006/02/09 21:51:44 michael Exp $
+# $Id: Makefile,v 1.2 2006/02/09 23:21:28 michael Exp $
 
 # Core functionality.
 mtd-y				:= mtdcore.o
 mtd-$(CONFIG_MTD_PARTITIONS)	+= mtdpart.o
-obj-$(CONFIG_MTD)		+= $(mtd-y)
+obj-$(CONFIG_MTD2K)		+= $(mtd-y)
 
 obj-$(CONFIG_MTD_CONCAT)        += mtdconcat.o
 obj-$(CONFIG_MTD_REDBOOT_PARTS) += redboot.o
Index: drivers/mtd2k/chips/Config.in
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/mtd2k/chips/Config.in,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/mtd2k/chips/Config.in	9 Feb 2006 21:52:09 -0000	1.1
+++ drivers/mtd2k/chips/Config.in	9 Feb 2006 23:23:12 -0000	1.2
@@ -1,13 +1,13 @@
 # drivers/mtd/chips/Config.in
 
-# $Id: Config.in,v 1.1 2006/02/09 21:52:09 michael Exp $
+# $Id: Config.in,v 1.2 2006/02/09 23:23:12 michael Exp $
 
 mainmenu_option next_comment
 
 comment 'RAM/ROM/Flash chip drivers'
 
-dep_tristate '  Detect flash chips by Common Flash Interface (CFI) probe' CONFIG_MTD_CFI $CONFIG_MTD
-dep_tristate '  Detect JEDEC JESD21c compatible flash chips' CONFIG_MTD_JEDECPROBE $CONFIG_MTD
+dep_tristate '  Detect flash chips by Common Flash Interface (CFI) probe' CONFIG_MTD_CFI $CONFIG_MTD2K
+dep_tristate '  Detect JEDEC JESD21c compatible flash chips' CONFIG_MTD_JEDECPROBE $CONFIG_MTD2K
 
 if [ "$CONFIG_MTD_CFI" = "y" -o "$CONFIG_MTD_JEDECPROBE" = "y" ]; then
    define_bool CONFIG_MTD_GEN_PROBE y
@@ -69,8 +69,8 @@
 
 bool '  Older (theoretically obsoleted now) drivers for non-CFI chips' CONFIG_MTD_OBSOLETE_CHIPS
 dep_tristate '  AMD compatible flash chip support (non-CFI)' CONFIG_MTD_AMDSTD $CONFIG_MTD $CONFIG_MTD_OBSOLETE_CHIPS
-dep_tristate '  pre-CFI Sharp chip support' CONFIG_MTD_SHARP $CONFIG_MTD $CONFIG_MTD_OBSOLETE_CHIPS
-dep_tristate '  JEDEC device support' CONFIG_MTD_JEDEC $CONFIG_MTD $CONFIG_MTD_OBSOLETE_CHIPS
+dep_tristate '  pre-CFI Sharp chip support' CONFIG_MTD_SHARP $CONFIG_MTD2K $CONFIG_MTD_OBSOLETE_CHIPS
+dep_tristate '  JEDEC device support' CONFIG_MTD_JEDEC $CONFIG_MTD2K $CONFIG_MTD_OBSOLETE_CHIPS
 
 
 endmenu
Index: drivers/mtd2k/chips/Makefile.common
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/mtd2k/chips/Makefile.common,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/mtd2k/chips/Makefile.common	9 Feb 2006 21:52:09 -0000	1.1
+++ drivers/mtd2k/chips/Makefile.common	9 Feb 2006 23:26:31 -0000	1.2
@@ -1,7 +1,7 @@
 #
 # linux/drivers/chips/Makefile
 #
-# $Id: Makefile.common,v 1.1 2006/02/09 21:52:09 michael Exp $
+# $Id: Makefile.common,v 1.2 2006/02/09 23:26:31 michael Exp $
 
 #                       *** BIG UGLY NOTE ***
 #
@@ -10,7 +10,7 @@
 # here where previously there was none.  We now have to ensure that
 # the CFI command set drivers are linked before gen_probe.o
 
-obj-$(CONFIG_MTD)		+= chipreg.o
+obj-$(CONFIG_MTD2K)		+= chipreg.o
 obj-$(CONFIG_MTD_AMDSTD)	+= amd_flash.o 
 obj-$(CONFIG_MTD_CFI)		+= cfi_probe.o
 obj-$(CONFIG_MTD_CFI_UTIL)	+= cfi_util.o
Index: drivers/mtd2k/nand/Config.in
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/mtd2k/nand/Config.in,v
retrieving revision 1.1
retrieving revision 1.5
diff -u -r1.1 -r1.5
--- drivers/mtd2k/nand/Config.in	9 Feb 2006 21:53:06 -0000	1.1
+++ drivers/mtd2k/nand/Config.in	16 Jan 2009 18:48:36 -0000	1.5
@@ -1,12 +1,12 @@
 # drivers/mtd/nand/Config.in
 
-# $Id: Config.in,v 1.1 2006/02/09 21:53:06 michael Exp $
+# $Id: Config.in,v 1.5 2009/01/16 18:48:36 eddie Exp $
 
 mainmenu_option next_comment
 
 comment 'NAND Flash Device Drivers'
 
-dep_tristate '  NAND Device Support' CONFIG_MTD_NAND $CONFIG_MTD
+dep_tristate '  NAND Device Support' CONFIG_MTD_NAND $CONFIG_MTD2K
 if [ "$CONFIG_MTD_NAND" = "y" -o "$CONFIG_MTD_NAND" = "m" ]; then
    bool '    Verify NAND page writes' CONFIG_MTD_NAND_VERIFY_WRITE
 fi
@@ -17,6 +17,9 @@
    dep_tristate ' SmartMedia Card on AUTCPU12 board' CONFIG_MTD_NAND_AUTCPU12 $CONFIG_MTD_NAND $CONFIG_ARCH_AUTCPU12
    dep_tristate '  NAND Flash device on EDP7312 board' CONFIG_MTD_NAND_EDB7312 $CONFIG_MTD_NAND $CONFIG_ARCH_EDB7312
    dep_tristate '  NAND Flash device on TS-7250 board' CONFIG_MTD_NAND_TS7250 $CONFIG_MTD_NAND
+   dep_tristate '  NAND Flash device on TS-7400 board' CONFIG_MTD_NAND_TS7400 $CONFIG_MTD_NAND
+   dep_tristate '  NAND Flash device on BT200 board' CONFIG_MTD_NAND_BT200 $CONFIG_MTD_NAND
+   dep_tristate '  NAND Flash device on Prosoft 8000 board' CONFIG_MTD_NAND_PROSOFT $CONFIG_MTD_NAND
 fi
 
 if [ "$CONFIG_MTD_DOC2001PLUS" = "y" -o "$CONFIG_MTD_DOC2001" = "y" -o "$CONFIG_MTD_DOC2000" = "y" -o "$CONFIG_MTD_NAND" = "y" ]; then
Index: drivers/mtd2k/nand/Makefile.common
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/mtd2k/nand/Makefile.common,v
retrieving revision 1.1
retrieving revision 1.4
diff -u -r1.1 -r1.4
--- drivers/mtd2k/nand/Makefile.common	9 Feb 2006 21:53:06 -0000	1.1
+++ drivers/mtd2k/nand/Makefile.common	16 Jan 2009 18:50:18 -0000	1.4
@@ -1,7 +1,7 @@
 #
 # linux/drivers/nand/Makefile
 #
-# $Id: Makefile.common,v 1.1 2006/02/09 21:53:06 michael Exp $
+# $Id: Makefile.common,v 1.4 2009/01/16 18:50:18 eddie Exp $
 
 obj-$(CONFIG_MTD_NAND)			+= nand.o nand_ecc.o
 obj-$(CONFIG_MTD_NAND_IDS)		+= nand_ids.o
@@ -19,6 +19,9 @@
 obj-$(CONFIG_MTD_NAND_H1900)		+= h1910.o
 obj-$(CONFIG_MTD_NAND_RTC_FROM4)	+= rtc_from4.o
 obj-$(CONFIG_MTD_NAND_TS7250)		+= ts7250.o
+obj-$(CONFIG_MTD_NAND_BT200)		+= ts7400.o
+obj-$(CONFIG_MTD_NAND_TS7400)		+= ts7400.o
+obj-$(CONFIG_MTD_NAND_PROSOFT)		+= ts7350.o
 
 nand-objs = nand_ecc.o nand_ids.o
 
Index: drivers/mtd2k/nand/makeModules
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/mtd2k/nand/makeModules,v
retrieving revision 1.1
retrieving revision 1.3
diff -u -r1.1 -r1.3
--- drivers/mtd2k/nand/makeModules	9 Feb 2006 21:53:06 -0000	1.1
+++ drivers/mtd2k/nand/makeModules	19 Oct 2006 17:34:17 -0000	1.3
@@ -1,6 +1,10 @@
 CMD="/home/michael/ts-7200/tools/crosstool/arm-9tdmi-linux-gnu/gcc-3.3.4-glibc-2.3.2/bin/arm-9tdmi-linux-gnu-gcc -D__KERNEL__ -I/home/michael/ts-7200/dist/linux24/include -Wall -Wstrict-prototypes -Wno-trigraphs -Os -fno-strict-aliasing -fno-common -Uarm -fno-common -pipe -mapcs-32 -D__LINUX_ARM_ARCH__=4 -march=armv4 -mtune=arm9tdmi -msoft-float -Uarm -DMODULE  -nostdinc -iwithprefix include -DKBUILD_BASENAME=p80211mod  -DEXPORT_SYMTAB -c"
-`$CMD nand_ecc.c`
-`$CMD nand_ids.c`
-`$CMD nand.c`
-`$CMD ts7250.c`
-cp *.o /mnt/tmp
+`$CMD nand_ecc2k.c`
+`$CMD nand_ids2k.c`
+`$CMD nand2k.c`
+`$CMD ts72502k.c`
+sudo cp nand_ecc2k.o /u/x/lib/modules/2.4.26-ts11/kernel/drivers/mtd2k/nand/
+sudo cp nand_ids2k.o /u/x/lib/modules/2.4.26-ts11/kernel/drivers/mtd2k/nand/
+sudo cp nand2k.o /u/x/lib/modules/2.4.26-ts11/kernel/drivers/mtd2k/nand/
+sudo cp ts72502k.o /u/x/lib/modules/2.4.26-ts11/kernel/drivers/mtd2k/nand/
+
Index: drivers/mtd2k/nand/nand.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/mtd2k/nand/nand.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/mtd2k/nand/nand.c	9 Feb 2006 21:53:06 -0000	1.1
+++ drivers/mtd2k/nand/nand.c	22 Jan 2009 18:14:20 -0000	1.2
@@ -34,7 +34,7 @@
  *	Check if buffering the last not aligned read can speed up
  *	performance
  *
- * $Id: nand.c,v 1.1 2006/02/09 21:53:06 michael Exp $
+ * $Id: nand.c,v 1.2 2009/01/22 18:14:20 eddie Exp $
  *
  * This program is free software; you can redistribute it and/or modify
  * it under the terms of the GNU General Public License version 2 as
@@ -1737,7 +1737,7 @@
 	instr->state = MTD_ERASING;
 
 	while (len) {
-		/* Check if we have a bad block, we do not erase bad blocks ! */
+		/* Check if we have a bad block, we do not erase bad blocks ! 
 		if (this->block_bad(mtd, (loff_t) page, 0)) {
 			// COMMENT THIS OUT TO ENABLE ERASURE OF BAD BLOCKS
 			// Only useful for erasing accidentally marked bad blocks
@@ -1747,6 +1747,7 @@
 			goto erase_exit;
 			
 		}
+		*/
 
 		/* Send commands to erase a page */
 		this->cmdfunc (mtd, NAND_CMD_ERASE1, -1, page);
@@ -1958,10 +1959,18 @@
 			extid >>= 2;
 			/* Get buswidth information */
 			busw = (extid & 0x01) ? NAND_BUSWIDTH_16 : 0;
-		
+/*
+printk("page size = 0x%x\n", mtd->oobblock);	
+printk("oob size = 0x%x\n", mtd->oobsize);	
+printk("erase size = 0x%x\n", mtd->erasesize);	
+printk("busw= 0x%x\n", busw);	
+*/
+
+
 			/* Do not replace user supplied command function ! */
-			if (this->cmdfunc == nand_command)
+			if (this->cmdfunc == nand_command) {
 				this->cmdfunc = nand_command_lp;
+			}
 		} else {
 			/* Old devices have this data hardcoded in the
 			 * device id table */
@@ -2028,11 +2037,13 @@
 	}
 	if (i > 1)
 		printk(KERN_INFO "%d NAND chips detected\n", i);
-	
+
+	/*
 	if (!this->oob_buf || !this->data_buf) {
 		printk (KERN_WARNING "nand_scan(): Buffers not set. Scan aborted\n"); 
 		return 1;
 	}
+	*/
 
 	/* Store the number of chips and calc total size for mtd */
 	this->numchips = i;
Index: drivers/mtd2k/nand/nand_ecc.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/mtd2k/nand/nand_ecc.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/mtd2k/nand/nand_ecc.c	9 Feb 2006 21:53:06 -0000	1.1
+++ drivers/mtd2k/nand/nand_ecc.c	27 Apr 2006 21:14:31 -0000	1.2
@@ -4,7 +4,7 @@
  *  Copyright (C) 2000 Steven J. Hill (sjhill@realitydiluted.com)
  *                     Toshiba America Electronics Components, Inc.
  *
- * $Id: nand_ecc.c,v 1.1 2006/02/09 21:53:06 michael Exp $
+ * $Id: nand_ecc.c,v 1.2 2006/04/27 21:14:31 eddie Exp $
  *
  * This program is free software; you can redistribute it and/or
  * modify it under the terms of the GNU Lesser General Public License
@@ -85,7 +85,7 @@
 /*
  * Calculate 3 byte ECC code for 256 byte block
  */
-void nand_calculate_ecc(struct mtd_info *mtd, const u_char *dat, u_char *ecc_code)
+int nand_calculate_ecc(struct mtd_info *mtd, const u_char *dat, u_char *ecc_code)
 {
 	u_char idx, reg1, reg2, reg3;
 	int j;
@@ -115,6 +115,8 @@
 	ecc_code[0] = ~ecc_code[0];
 	ecc_code[1] = ~ecc_code[1];
 	ecc_code[2] = ((~reg1) << 2) | 0x03;
+
+	return 0;
 }
 
 /*
Index: drivers/mtd2k/nand/ts7250.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/mtd2k/nand/ts7250.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/mtd2k/nand/ts7250.c	9 Feb 2006 21:53:06 -0000	1.1
+++ drivers/mtd2k/nand/ts7250.c	6 Mar 2007 22:26:40 -0000	1.2
@@ -9,7 +9,7 @@
  *  Derived from drivers/mtd/nand/autcpu12.c
  *       Copyright (c) 2001 Thomas Gleixner (gleixner@autronix.de)
  *
- * $Id: ts7250.c,v 1.1 2006/02/09 21:53:06 michael Exp $
+ * $Id: ts7250.c,v 1.2 2007/03/06 22:26:40 eddie Exp $
  *
  * This program is free software; you can redistribute it and/or modify
  * it under the terms of the GNU General Public License version 2 as
@@ -290,6 +290,7 @@
   //	struct nand_chip *this = (struct nand_chip *) &ts7250_mtd[1];
 	
 	/* Unregister the device */
+	del_mtd_partitions(ts7250_mtd);
 	del_mtd_device (ts7250_mtd);
 	
 	/* Free the MTD device structure */
